use arduino_hal::{
    hal::port::Dynamic,
    port::{
        mode::{Input, PullUp},
        Pin,
    },
};

pub const BUTTON_COUNT: usize = 8;
// pub const DEBOUNCE_DELAY: u64 = 50;

pub struct Button {
    pub index: usize,
    pub pin: Pin<Input<PullUp>, Dynamic>,
    pub is_low: bool,
    // pub last_debounce_time: u64,
}

impl Button {
    pub fn new(index: usize, pin: Pin<Input<PullUp>, Dynamic>) -> Self {
        Button {
            index,
            pin,
            is_low: true,
            // last_debounce_time: 0,
        }
    }

    pub fn check_state<F>(&mut self, mut f: F)
    where
        F: FnMut(usize, bool),
    {
        match (self.pin.is_high(), self.is_low) {
            (true, true) | (false, false) => {
                self.is_low = !self.is_low;

                f(self.index, !self.is_low);
            }

            _ => (),
        }
    }
}
